// This document is part of the QuantLib.NET class library.
// For more information, see http://www.quantlib.net/ or 
// contact Jens Thiel <mailto:jens@stochastix.de>.

#region Copyright  2002 Jens Thiel and others. All rights reserved.
/*
 ***************************************************** \begincopyright
 *
 * Copyright (c) 2001, 2002 Jens Thiel (http://www.jens-thiel.de/)
 * Copyright (c) 2002 Ferdinando Ametrano
 * Copyright (c) 2001, 2002 Nicolas Di Csar
 * Copyright (c) 2001, 2002 Sadruddin Rejeb
 * Copyright (c) 2000, 2001, 2002 RiskMap srl
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions 
 * are met:
 *
 *   Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 *   Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the 
 *   distribution.
 * 
 *   Neither the names of the copyright holders nor the names of the
 *   QuantLib Group and its contributors may be used to endorse or
 *   promote products derived from this software without specific
 *   prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ******************************************************* \endcopyright
 */
#endregion

#region RCS Log
/*
 *********************************************************** \internal
 *
 *  $Log: XiborHistoryDialog.cs,v $
 *  Revision 1.1.1.1  2003/02/01 19:01:28  jens
 *  Initial import
 *
 *  Revision 1.1  2002/08/15 18:18:23  stochastix
 *  Preparing for preview release
 *
 *  Revision 1.2  2002/07/24 17:04:27  stochastix
 *  Preparing for preview release
 *
 *  Revision 1.1  2002/07/24 14:42:42  stochastix
 *  Preparing for preview release
 *
 *
 *********************************************************************
 */
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.Runtime.InteropServices;	// COM interop attributes
using System.ComponentModel;			// some useful attributes
using System.Windows.Forms;

namespace QuantLib.Indexes
{
	/// <summary>
	/// Summary description for XiborHistoryDialog.
	/// </summary>
	[
	ComVisible(false)
	]
	public class XiborHistoryDialog : System.Windows.Forms.Form, IXiborHistory
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.TextBox fixedRate;
		private System.Windows.Forms.Label label2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public XiborHistoryDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.buttonOK = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.fixedRate = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(264, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Enter fixing for {0}-{1} on {2}:";
			// 
			// buttonOK
			// 
			this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonOK.Location = new System.Drawing.Point(104, 96);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.Size = new System.Drawing.Size(72, 24);
			this.buttonOK.TabIndex = 1;
			this.buttonOK.Text = "OK";
			// 
			// buttonCancel
			// 
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonCancel.Location = new System.Drawing.Point(184, 96);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.Size = new System.Drawing.Size(88, 24);
			this.buttonCancel.TabIndex = 2;
			this.buttonCancel.Text = "Cancel";
			// 
			// fixedRate
			// 
			this.fixedRate.Location = new System.Drawing.Point(184, 56);
			this.fixedRate.Name = "fixedRate";
			this.fixedRate.Size = new System.Drawing.Size(56, 21);
			this.fixedRate.TabIndex = 3;
			this.fixedRate.Text = "2";
			this.fixedRate.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.fixedRate.TextChanged += new System.EventHandler(this.fixedRate_TextChanged);
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(246, 59);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(16, 19);
			this.label2.TabIndex = 4;
			this.label2.Text = "%";
			// 
			// XiborHistoryDialog
			// 
			this.AcceptButton = this.buttonOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.CancelButton = this.buttonCancel;
			this.ClientSize = new System.Drawing.Size(288, 132);
			this.ControlBox = false;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.fixedRate,
																		  this.label2,
																		  this.buttonCancel,
																		  this.buttonOK,
																		  this.label1});
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MinimizeBox = false;
			this.Name = "XiborHistoryDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Historic Fixing";
			this.ResumeLayout(false);

		}
		#endregion

		#region Implementation of IXiborHistory
		// public string ToString()

		public double Fixing(string familyName, string tenor, System.DateTime fixingDate)
		{
			this.label1.Text = String.Format(
				"Enter fixing for {0}-{1} on {2}:",
				familyName, tenor, fixingDate.ToShortDateString()
			);
			if (this.ShowDialog() == DialogResult.OK)
			{
				this.Hide();
				return double.Parse(fixedRate.Text) / 100.0;
			}
			else
			{
				this.Hide();
				throw new ApplicationException("User cancelled dialog");
			}
		}
		#endregion

		private void fixedRate_TextChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
